﻿using Announcements.Contracts;
using Announcements.Database.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Announcements
{
    public partial class AnnouncementCreateForm : Form
    {
        IBlockingLogic blockingLogic;
        IAnnouncementLogic announcementLogic;
        ICategoryLogic categoryLogic;

        public AnnouncementCreateForm(IBlockingLogic blockingLogic, IAnnouncementLogic announcementLogic, ICategoryLogic categoryLogic)
        {
            this.blockingLogic = blockingLogic;
            this.announcementLogic = announcementLogic;
            this.categoryLogic = categoryLogic;
            InitializeComponent();
        }

        private void AnnouncementCreateForm_Load(object sender, EventArgs e)
        {
            comboBox1.Items.Clear();
            comboBox1.DataSource = categoryLogic.ReadList().Select(i => i.name).ToList();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            var cat = categoryLogic.ReadList().Where(i => i.name == comboBox1.Text).Select(i => i).FirstOrDefault();
            var res = announcementLogic.CreateAnnouncement(new Announcement
            {
                id = announcementLogic.ReadList().Count() + 1,
                text = textBox1.Text,
                createDate = DateTime.Now,
                complaints = 0,
                isClose = false,
                categoryId = cat,
                authorId = MainForm.user,
                blockingId = blockingLogic.ReadList().Where(b => b.name == "null").FirstOrDefault(),
            }) ;
            if (!res)
            {
                MessageBox.Show("Произошла ошибка");
            }
            else MessageBox.Show("Успешно");
        }
    }
}
