﻿using Announcements.Contracts;
using Announcements.Database.Implements;
using Announcements.Database.Models;
using Announcements.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Announcements
{
    public partial class AuthForm : Form
    {
        IUserLogic userLogic;
        IAnnouncementLogic announcementLogic;
        public AuthForm(IUserLogic userLogic, IAnnouncementLogic announcementLogic)
        {
            InitializeComponent();
            this.userLogic = userLogic;
            this.announcementLogic = announcementLogic;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            var user = userLogic.ReadList().Where(i => (i.name == textBox1.Text && i.password == textBox2.Text)).FirstOrDefault();
            if (user != null)
            {
                MainForm.user = user;
                MainForm form = new MainForm(announcementLogic, new CategoryLogic(), new BlockingLogic());
                form.Show();
            }
            else
            {
                MessageBox.Show("Нет пользователя с такими данными");
            }
        }


        private void button2_Click(object sender, EventArgs e)
        {
            var user = new User
            {
                id = userLogic.ReadList().Count() + 1,
                name = textBox3.Text,
                surname = textBox4.Text,
                patronymic = textBox5.Text,
                email = textBox6.Text,
                password = textBox7.Text,
                registrDate = DateTime.Now,
                rating = 0,
                isAdmin = false,
            };
            var res = userLogic.CreateUser(user);
            if (!res)
            {
                MessageBox.Show("Возникла ошибка");
                return;
            }
            MainForm.user = user;
            MainForm form = new MainForm(announcementLogic, new CategoryLogic(), new BlockingLogic());
            form.Show();
        }
    }
}
