﻿using Announcements.Contracts;
using Announcements.Database.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Announcements
{
    public partial class BlockingForm : Form
    {
        IBlockingLogic blockingLogic;
        public BlockingForm(IBlockingLogic blockingLogic)
        {
            InitializeComponent();
            this.blockingLogic = blockingLogic;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            var block = blockingLogic.ReadList();
            if (block.Select(b => b.name.ToLower()).Contains(textBox1.Text.ToLower()))
                {
                MessageBox.Show("Такая блокировка уже есть");
                return;
            }
            var res = blockingLogic.CreateBlocking(new Blocking
            {
                id = block.Count() + 1,
                name = textBox1.Text
            });
            if (!res)
            {
                MessageBox.Show("Произошла ошибка");
            }
            else MessageBox.Show("Успешно");
        }
    }
}
