﻿using Announcements.Contracts;
using Announcements.Database.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Announcements
{
    public partial class CategoryForm : Form
    {
        ICategoryLogic categoryLogic;
        public CategoryForm(ICategoryLogic categoryLogic)
        {
            InitializeComponent();
            this.categoryLogic = categoryLogic;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            var cat = categoryLogic.ReadList();
            if (cat.Select(c => c.name.ToLower()).ToList().Contains(textBox1.Text.ToLower()))
            {
                MessageBox.Show("Такая категория уже есть");
                return;
            }
            var res = categoryLogic.CreateCategory(new Category
            {
                id = cat.Count() + 1,
                name = textBox1.Text
            }) ;
            if (!res)
            {
                MessageBox.Show("Произошла ошибка");
            }
            else MessageBox.Show("Успешно");
        }
    }
}
