﻿using Announcements.Contracts;
using Announcements.Database.Models;
using Announcements.Models;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Announcements.Database.Implements
{
    public class AnnouncementLogic : IAnnouncementLogic
    {

        ICategoryLogic categoryLogic;
        IUserLogic userLogic;
        IBlockingLogic blockingLogic;
        public AnnouncementLogic(ICategoryLogic _categoryLogic, IUserLogic _userlogic, IBlockingLogic _blockingLogic)
        {
            categoryLogic = _categoryLogic;
            userLogic = _userlogic;
            blockingLogic = _blockingLogic;

        }
        public bool BlockingAnnouncement(IAnnouncement model)
        {
            using (var _db = new DataBaseContext())
            {
                try
                {
                    _db.Database.ExecuteSqlRaw(@$"UPDATE public.blocking "+
                        @$"SET blockingid = {model.blockingId} WHERE id = {model.id}", new object[] { });
                    return true;
                }
                catch (Exception ex)
                {
                    return false;
                }
            }
        }

        public bool CreateAnnouncement(IAnnouncement model)
        {
            using (var _db = new DataBaseContext())
            {
                try
                {
                    var script = @$"INSERT INTO public.announcement " +
                    @$"(text, createdate, changedate, complaints, isclose, categoryid, authorid, blockingid)" +
                    $@"VALUES ('{model.text}', '{model.createDate}', '{model.changeDate}', " +
                    $@"{model.complaints}, {model.isClose}, {model.categoryId.id}, {model.authorId.id}, {model.blockingId?.id.ToString()}); ";
                    _db.Database.ExecuteSqlRaw(script, new object[] { });
                    return true;
                }
                catch (Exception ex)
                {
                    return false;
                }
            }
        }

        public bool DeleteAnnouncement(IAnnouncement model)
        {
            using (var _db = new DataBaseContext())
            {
                try
                {
                    _db.Database.ExecuteSqlRaw(@$"DELETE FROM public.announcement " +
                       @$" WHERE id = {model.id}; ", new object[] { });
                    return true;
                }
                catch (Exception ex)
                {
                    return false;
                }
            }
        }

        public IAnnouncement? ReadElement(int id)
        {
            using (var _db = new DataBaseContext())
            {
                using (var command = _db.Database.GetDbConnection().CreateCommand())
                {
                    command.CommandText = $"SELECT * FROM public.announcement WHERE id = {id}";
                    command.CommandType = CommandType.Text;

                    _db.Database.OpenConnection();

                    using (var result = command.ExecuteReader())
                    {
                        Announcement announcement = new Announcement();

                        while (result.Read())
                        {
                            announcement = new Announcement
                            {
                                id = Convert.ToInt32(result["id"]),
                                text = result["text"].ToString(),
                                createDate = Convert.ToDateTime(result["createdate"]),
                                changeDate = Convert.ToDateTime(result["changedate"]),
                                complaints = Convert.ToInt32(result["complaints"]),
                                isClose = (bool)result["isclose"],
                                categoryId = categoryLogic.ReadElement(Convert.ToInt32(result["categoryId"])),
                                authorId = userLogic.ReadElement(Convert.ToInt32(result["authorid"])),
                                blockingId = blockingLogic.ReadElement(Convert.ToInt32(result["blockingid"]))
                            };
                        }

                        return announcement;
                    }
                }
            }
        }

        public List<IAnnouncement>? ReadList()
        {
            using (var _db = new DataBaseContext())
            {
                using (var command = _db.Database.GetDbConnection().CreateCommand())
                {
                    command.CommandText = "SELECT * FROM public.announcement";
                    command.CommandType = CommandType.Text;

                    _db.Database.OpenConnection();

                    using (var result = command.ExecuteReader())
                    {
                        var entities = new List<IAnnouncement>();

                        while (result.Read())
                        {
                            entities.Add(new Announcement
                            {
                                id = Convert.ToInt32(result["id"]),
                                text = result["text"].ToString(),
                                createDate = Convert.ToDateTime(result["createdate"]),
                                changeDate = Convert.ToDateTime(result["changedate"]),
                                complaints = Convert.ToInt32(result["complaints"]),
                                isClose = (bool)result["isclose"],
                                categoryId = categoryLogic.ReadElement(Convert.ToInt32(result["categoryid"])),
                                authorId = userLogic.ReadElement(Convert.ToInt32(result["authorid"])),
                                blockingId = blockingLogic.ReadElement(Convert.ToInt32(result["blockingid"]))
                            });
                        }

                        return entities;
                    }
                }
            }
        }


        public bool UpdateAnnouncement(IAnnouncement model)
        {
            using (var _db = new DataBaseContext())
            {
                try
                {
                    var script = @$"UPDATE public.announcement " +
                            $"SET text='{model.text}', createdate='{model.createDate}', changedate='{model.changeDate}', complaints={model.complaints}, " +
                            $"isclose={model.isClose}, categoryid={model.categoryId.id}, authorid={model.authorId.id}, blockingid={model.blockingId.id} " +
                            $"WHERE id = {model.id}";
                    _db.Database.ExecuteSqlRaw(script, new object[] { });
                    return true;
                }
                catch (Exception ex)
                {
                    return false;
                }
            }
        }
    }
}
