﻿using Announcements.Contracts;
using Announcements.Database.Models;
using Announcements.Models;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Announcements.Database.Implements
{
    public class BlockingLogic : IBlockingLogic
    {
        public bool CreateBlocking(IBlocking model)
        {
            using (var _db = new DataBaseContext())
            {
                try
                {
                    _db.Database.ExecuteSqlRaw(@$"INSERT INTO public.blocking" +
                        @$"(name)" +
                        @$"VALUES ('{model.name}');", new object[] { });
                    return true;
                }
                catch (Exception ex)
                {
                    return false;
                }
            }
        }

        public bool DeleteBlocking(IBlocking model)
        {
            using (var _db = new DataBaseContext())
            {
                try
                {
                    _db.Database.ExecuteSqlRaw(@$"DELETE FROM public.blocking " +
                       @$" WHERE id = {model.id}; ", new object[] { });
                    return true;
                }
                catch (Exception ex)
                {
                    return false;
                }
            }
        }

        public IBlocking? ReadElement(int id)
        {
            using (var _db = new DataBaseContext())
            {
                using (var command = _db.Database.GetDbConnection().CreateCommand())
                {
                    command.CommandText = $"SELECT * FROM public.blocking WHERE id = {id}";
                    command.CommandType = CommandType.Text;

                    _db.Database.OpenConnection();

                    using (var result = command.ExecuteReader())
                    {
                        Blocking blocking = new Blocking();

                        while (result.Read())
                        {
                            blocking = new Blocking
                            {
                                id = Convert.ToInt32(result["id"]),
                                name = result["name"].ToString()
                            };
                        }

                        return blocking;
                    }
                }
            }
        }

        public List<IBlocking>? ReadList()
        {
            using (var _db = new DataBaseContext())
            {
                using (var command = _db.Database.GetDbConnection().CreateCommand())
                {
                    command.CommandText = "SELECT * FROM public.blocking";
                    command.CommandType = CommandType.Text;

                    _db.Database.OpenConnection();

                    using (var result = command.ExecuteReader())
                    {
                        var entities = new List<IBlocking>();

                        while (result.Read())
                        {
                            entities.Add(new Blocking
                            {
                                id = Convert.ToInt32(result["id"]),
                                name = result["name"].ToString()
                            });
                        }

                        return entities;
                    }
                }
            }
        }


        public bool UpdateBlocking(IBlocking model)
        {
            using (var _db = new DataBaseContext())
            {
                try
                {
                    _db.Database.ExecuteSqlRaw(@$"UPDATE public.blocking " +
                        @$"SET name = {model.name} " +
                        @$"WHERE id = {model.id}", new object[] { });
                    return true;
                }
                catch (Exception ex)
                {
                    return false;
                }
            }
        }
    }
}
