﻿using Announcements.Contracts;
using Announcements.Database.Models;
using Announcements.Models;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Announcements.Database.Implements
{
    public class ReviewLogic : IReviewLogic
    {
        IAnnouncementLogic announcementLogic;
        IBlockingLogic blockingLogic;
        IUserLogic userLogic;

        public ReviewLogic(IAnnouncementLogic announcementLogic, IBlockingLogic blockingLogic, IUserLogic userLogic)
        {
            this.announcementLogic = announcementLogic;
            this.blockingLogic = blockingLogic;
            this.userLogic = userLogic;
        }

        public bool BlockingReview(IReview model)
        {
            using (var _db = new DataBaseContext())
            {
                try
                {
                    _db.Database.ExecuteSqlRaw(@$"UPDATE public.review SET isadmin = true WHERE id = {model.id}", new object[] { });
                    return true;
                }
                catch (Exception ex)
                {
                    return false;
                }
            }
        }

        public bool CreateReview(IReview model)
        {
            using (var _db = new DataBaseContext())
            {
                try
                {
                    _db.Database.ExecuteSqlRaw(@$"INSERT INTO public.review "+
                    $"(text, createdate, complaints, announcementid, authorid, blockingid) "+
                    $"VALUES('{model.text}', '{model.createDate}', {model.complaints}, {model.announcementId.id}, "+
                    $"{model.authorId.id}, {model.blockingId.id}); ", new object[] { });
                    return true;
                }
                catch (Exception ex)
                {
                    return false;
                }
            }
        }

        public bool DeleteReview(IReview model)
        {
            using (var _db = new DataBaseContext())
            {
                try
                {
                    _db.Database.ExecuteSqlRaw(@$"DELETE FROM public.review " +
                       @$" WHERE id = {model.id}; ", new object[] { });
                    return true;
                }
                catch (Exception ex)
                {
                    return false;
                }
            }
        }

        public IReview? ReadElement(int id)
        {
            using (var _db = new DataBaseContext())
            {
                using (var command = _db.Database.GetDbConnection().CreateCommand())
                {
                    command.CommandText = $"SELECT * FROM public.review WHERE id = {id}";
                    command.CommandType = CommandType.Text;

                    _db.Database.OpenConnection();

                    using (var result = command.ExecuteReader())
                    {
                        Review review = new Review();

                        while (result.Read())
                        {
                            review = new Review
                            {
                                id = Convert.ToInt32(result["id"]),
                                text = result["text"].ToString(),
                                createDate = Convert.ToDateTime(result["createdate"]),
                                complaints = Convert.ToInt32(result["complaints"]),
                                announcementId = announcementLogic.ReadElement(Convert.ToInt32(result["announcementId"])),
                                authorId = userLogic.ReadElement(Convert.ToInt32(result["authorid"])),
                                blockingId = blockingLogic.ReadElement(Convert.ToInt32(result["blockingId"]))
                            };
                        }

                        return review;
                    }
                }
            }
        }

        public List<IReview>? ReadList()
        {
            using (var _db = new DataBaseContext())
            {
                using (var command = _db.Database.GetDbConnection().CreateCommand())
                {
                    command.CommandText = $"SELECT * FROM public.review";
                    command.CommandType = CommandType.Text;

                    _db.Database.OpenConnection();

                    using (var result = command.ExecuteReader())
                    {
                        var reviews = new List<IReview>();

                        while (result.Read())
                        {
                            reviews.Add(new Review
                            {
                                id = Convert.ToInt32(result["id"]),
                                text = result["text"].ToString(),
                                createDate = Convert.ToDateTime(result["createdate"]),
                                complaints = Convert.ToInt32(result["complaints"]),
                                announcementId = announcementLogic.ReadElement(Convert.ToInt32(result["announcementId"])),
                                authorId = userLogic.ReadElement(Convert.ToInt32(result["authorid"])),
                                blockingId = blockingLogic.ReadElement(Convert.ToInt32(result["blockingId"]))
                            });
                        }

                        return reviews;
                    }
                }
            }
        }

        public bool UpdateReview(IReview model)
        {
            using (var _db = new DataBaseContext())
            {
                try
                {
                    _db.Database.ExecuteSqlRaw(@$"UPDATE public.review "+
                    @$"SET text={model.text}, createdate={model.createDate}, complaints={model.complaints}, announcementid={model.announcementId.id}, "+
                    @$"authorid={model.authorId.id}, blockingid={model.blockingId.id} "+
                    @$" WHERE id = ", new object[] { });
                    return true;
                }
                catch (Exception ex)
                {
                    return false;
                }
            }
        }
    }
}
