﻿using Announcements.Contracts;
using Announcements.Database.Models;
using Announcements.Models;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Announcements.Database.Implements
{
    public class UserLogic : IUserLogic
    {
        public bool BlockingUser(IUser model)
        {
            using (var _db = new DataBaseContext())
            {
                try
                {
                    _db.Database.ExecuteSqlRaw(@$"UPDATE public.user SET isadmin = true WHERE id = {model.id}", new object[] { });
                    return true;
                }
                catch (Exception ex)
                {
                    return false;
                }
            }
        }

        public bool CreateUser(IUser model)
        {
            using (var _db = new DataBaseContext())
            {
                try
                {
                    _db.Database.ExecuteSqlRaw(@$"INSERT INTO public.user"+
                        @$"(name, surname, patronymic, email, password, registrdate, rating, isadmin)"+
                        @$"VALUES ('{model.name}', '{model.surname}', '{model.patronymic}', '{model.email}', "+
                        @$"'{model.password}', '{model.registrDate}'::timestamp, '{model.rating}', '{model.isAdmin}');", new object[] { });
                    return true;
                }
                catch (Exception ex)
                {
                    return false;
                }
            }
        }

        public bool DeleteUser(IUser model)
        {
            using (var _db = new DataBaseContext())
            {
                try
                {
                    _db.Database.ExecuteSqlRaw(@$"DELETE FROM public.user "+
                       @$" WHERE id = {model.id}; ", new object[] { });
                    return true;
                }
                catch (Exception ex)
                {
                    return false;
                }
            }
        }

        public IUser? ReadElement(int id)
        {
            using (var _db = new DataBaseContext())
            {
                using (var command = _db.Database.GetDbConnection().CreateCommand())
                {
                    command.CommandText = $"SELECT * FROM public.user WHERE id = {id}";
                    command.CommandType = CommandType.Text;

                    _db.Database.OpenConnection();

                    using (var result = command.ExecuteReader())
                    {
                        User user = new User();

                        while (result.Read())
                        {
                            user = new User
                            {
                                id = Convert.ToInt32(result["id"]),
                                name = result["name"].ToString(),
                                surname = result["surname"].ToString(),
                                patronymic = result["patronymic"].ToString(),
                                password = result["password"].ToString(),
                                email = result["email"].ToString(),
                                registrDate = Convert.ToDateTime(result["registrdate"]),
                                rating = (float)Convert.ToDecimal(result["rating"]),
                                isAdmin = (bool)result["isadmin"]
                            };
                        }

                        return user;
                    }
                }
            }
        }

        public List<IUser>? ReadList()
        {
            using (var _db = new DataBaseContext())
            {
                using (var command = _db.Database.GetDbConnection().CreateCommand())
                {
                    command.CommandText = "SELECT * FROM public.user";
                    command.CommandType = CommandType.Text;

                    _db.Database.OpenConnection();

                    using (var result = command.ExecuteReader())
                    {
                        var entities = new List<IUser>();

                        while (result.Read())
                        {
                            entities.Add(new User
                            {
                                id = Convert.ToInt32(result["id"]),
                                name = result["name"].ToString(),
                                surname = result["surname"].ToString(),
                                patronymic = result["patronymic"].ToString(),
                                password = result["password"].ToString(),
                                email = result["email"].ToString(),
                                registrDate = Convert.ToDateTime(result["registrdate"]),
                                rating = (float)(Convert.ToDouble(result["rating"])),
                                isAdmin = (bool)result["isadmin"]
                            });
                        }

                        return entities;
                    }
                }
            }
        }

        public bool UpdateUser(IUser model)
        {
            using (var _db = new DataBaseContext())
            {
                try
                {
                    _db.Database.ExecuteSqlRaw(@$"UPDATE public.user "+
                        @$"SET name = {model.name}, surname = {model.surname}, patronymic = {model.patronymic}, email = {model.email}, "+
                        @$"password = {model.password}, registrdate = {model.registrDate}, rating = {model.rating}, isadmin = {model.isAdmin} "+
                        @$"WHERE id = {model.id}", new object[] { });
                    return true;
                }
                catch (Exception ex)
                {
                    return false;
                }
            }
        }
    }
}
