using Announcements.Contracts;
using Announcements.Database.Implements;
using Announcements.Models;

namespace Announcements
{
    public partial class MainForm : Form
    {
        public static IUser user;
        IAnnouncementLogic announcementLogic;
        ICategoryLogic categoryLogic;
        List<IAnnouncement> announcements;
        IBlockingLogic blockingLogic;
        public MainForm(IAnnouncementLogic _announcementLogic, ICategoryLogic _categoryLogic, IBlockingLogic _blockingLogic)
        {
            InitializeComponent();
            announcementLogic = _announcementLogic;
            categoryLogic = _categoryLogic;
            blockingLogic = _blockingLogic;
        }

          void button1_Click(object sender, EventArgs e)
        {
            AnnouncementCreateForm announcementCreateForm = new AnnouncementCreateForm(blockingLogic, 
                                                announcementLogic, categoryLogic);
            announcementCreateForm.ShowDialog();
            this.Update();
        }

          void MainForm_Load(object sender, EventArgs e)
            {
            button1.Visible = false;
            button2.Visible = false;
            if (user.isAdmin)
                {
                    button1.Visible = true;
                    button2.Visible = true;
                }
                announcements = announcementLogic.ReadList();
                foreach(var announcement in announcements)
                {
                    LinkLabel link = new LinkLabel();
                    link.Text = announcement.text;
                    link.Location = new Point(83, 83 + 20*announcements.IndexOf(announcement));
                    link.Size = new Size(300, 23);
                    link.Click += ((sender, e) =>
                    {
                        AnnouncementReadForm form = new AnnouncementReadForm(blockingLogic, announcementLogic, categoryLogic, announcement, new ReviewLogic(announcementLogic, blockingLogic, new UserLogic()));
                        form.Show();
                        this.Update();
                    });
                    panel1.Controls.Add(link);
                }
            }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {

        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            CategoryForm cat = new CategoryForm(categoryLogic);
            cat.ShowDialog();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            BlockingForm blocking = new BlockingForm(blockingLogic);
            blocking.ShowDialog();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            MakeAdminForm makeAdmin = new MakeAdminForm(new UserLogic());
            makeAdmin.ShowDialog();
        }
    }
}