﻿using Announcements.Contracts;
using Announcements.Database.Models;
using Announcements.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Announcements
{
    public partial class MakeAdminForm : Form
    {
        IUserLogic userLogic;
        List<IUser> userAdmin = new List<IUser>();
        List<IUser> userNotAdmin = new List<IUser>();
        public MakeAdminForm(IUserLogic logic)
        {
            userLogic = logic;
            InitializeComponent();
            userAdmin = userLogic.ReadList().Where(u => !u.isAdmin).ToList();
            userNotAdmin = userLogic.ReadList().Where(u => !u.isAdmin).ToList();

        }

        private void MakeAdminForm_Load(object sender, EventArgs e)
        {
            comboBox1.DataSource = userAdmin.Select(u => u.name+" "+u.surname).ToList();
            comboBox2.DataSource = userNotAdmin.Select(u => u.name + " " + u.surname).ToList();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            var user = userAdmin.Where(u => (u.name+" "+u.surname) == comboBox1.Text).FirstOrDefault();
            var resUser = userLogic.UpdateUser(new User()
            {
                id = user.id,
                name = user.name,
                surname = user.surname,
                patronymic = user.patronymic,
                email = user.email,
                password = user.password,
                registrDate = user.registrDate,
                rating = (float)(user.rating),
                isAdmin = true,
            });
        }

        private void button2_Click(object sender, EventArgs e)
        {
            var user = userNotAdmin.Where(u => (u.name + " " + u.surname) == comboBox2.Text).FirstOrDefault();
            var resUser = userLogic.UpdateUser(new User()
            {
                id = user.id,
                name = user.name,
                surname = user.surname,
                patronymic = user.patronymic,
                email = user.email,
                password = user.password,
                registrDate = user.registrDate,
                rating = (float)(user.rating),
                isAdmin = false,
            });
        }
    }
}
